﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SDR_test1
{
    public partial class Form2 : Form
    {
        private double[] data;

        //　Form2を表示
        public Form2()
        {
            InitializeComponent();
        }

        //　Form1からデータを受け取る
        public double[] SendData
        {
            //　プロパティで値を取得する
            set
            {
                data = value;
                draw();
            }
        }

        //　グリッドと波形の描画
        private void draw()
        {
            //　画面サイズのパラメータ
            float pw = pictureBox1.Size.Width;                                            // Get Picture Box size
            float ph = pictureBox1.Size.Height;

            float pws = pw / 10;                                                          // Size of Div of Hrizon
            float pwh = pw / 2;                                                           // Center of Hrizon
            float pwb = pwh - 5 * pws;                                                    // Ref Line  of Hrizon

            float phs = ph / 10;                                                          // Size of Div of Vertical
            float phh = ph / 2;                                                           // Center of Vertical
            float phb = phh - 5 * phs;                                                    // Ref Line  of Vertical

            //　積分範囲を得る
            int bwstart = (int)data[512];
            int bwstop  = (int)data[513];

            //　画面を初期化
            pictureBox1.Image = null;                                                   // Picture Box Clear

            //　グラフィックス・オブジェクトの作成
            Graphics g1;
            Bitmap DrawArea;
            DrawArea = new Bitmap((int)pw,(int)ph);                                              // Picture Box Defined
            g1 = Graphics.FromImage(DrawArea);                                          // Make Graphics Object
            pictureBox1.Image = DrawArea;

            //　描画色の指定
            Pen bpen = new Pen(Color.Blue, 1);
            Pen rpen = new Pen(Color.Red, 1);
            Pen gpen = new Pen(Color.DarkGreen, 1);
            Pen apen = new Pen(Color.Aqua, 1);

            //　グリッド描画
            for (float y = phb; y <= ph; y = y + phs)                                     // Draw Horizon Lines
            {
                g1.DrawLine(gpen, 0, y, pw, y);
            }

            for (float w = pwb; w <= pw; w = w + pws)                                     // Draw Vertical Lines
            {
                g1.DrawLine(gpen, w, 0, w, ph);
            }

            //　波形描画
            for (int x = 1; x < 511; x++)
            {
                float y1 = phh - (float)phh * (float)data[x];
                float y2 = phh - (float)phh * (float)data[x + 1];
                float x1 = (float)(x * pw / 512);
                float x2 = (float)((x + 1) * pw / 512);

                if (x >= bwstart && x <= bwstop)
                {
                    g1.DrawLine(rpen, x1, y1, x2, y2);
                }
                else
                {
                    g1.DrawLine(apen, x1, y1, x2, y2);
                }
            }
        }

    }

}
